Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# FileKeyC Class Reference

File Keyframe class for controller. More...

`#include <KeyC.h>`

Inheritance diagram for FileKeyC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
virtual Edit::DataBlockI * | create (Edit::EditableI *pOriginal)
| Creates new file handle (used internally), see Edit::EditableI::create().
virtual void | copy (Edit::EditableI *pEditable)
| Deep copy from a data block, see Edit::DataBlockI::copy().
virtual void | restore (Edit::EditableI *pEditable)
| Shallow copy from a editable, see Edit::EditableI::restore().
virtual void | set_file_handle (Import::FileHandleC *pHandle)
| Sets the file handle used.
virtual Import::FileHandleC * | get_file_handle ()
| Returns the file handle used.
virtual void | set_time_scale (PajaTypes::float32 f32Scale)
| Sets the time scale.
virtual PajaTypes::float32 | get_time_scale () const
| Returns the time scale.
virtual void | set_time_offset (PajaTypes::int32 i32Offset)
| Sets the time offset.
virtual PajaTypes::int32 | get_time_offset () const
| Returns the time offset.
virtual PajaTypes::uint32 | save (FileIO::SaveC *pSave)
| Serialize the key to a Demopaja output stream.
virtual PajaTypes::uint32 | load (FileIO::LoadC *pLoad)
| Serialize the key from a Demopaja input stream.
## Static Public Member Functions
FileKeyC * | create_new ()
| Create new key with zero no channels.
## Protected Member Functions
| FileKeyC ()
| Default constructor.
| FileKeyC (PajaTypes::int32 i32Time)
| Creates new key and assign it the specified time.
| FileKeyC (Edit::EditableI *pOriginal)
| Constructor with reference to the original.
virtual | ~FileKeyC ()
| Default destructor.
## Protected Attributes
PajaTypes::int32 | m_i32TimeOffset
PajaTypes::float32 | m_f32TimeScale
Import::FileHandleC * | m_pFileHandle

## Detailed Description

File Keyframe class for controller.

The file key frame class has three properties: the file handle, file time offset and file time scale. The time properties are used to calculate the actual time used to evaluate the importable the file handle points. The time is calculate as follows:

Input: CurrentTime timeline time KeyTime time of the keyframe KeyTimeOffest time offset of the keyframe KeyTimeScale time scale of the keyframe Output: EvalTime time used to evaluate the importable

EvalTime = (CurrentTime - KeyTime + KeyOffsetTime) * KeyTimeScale

This class is implemented by the system.

## Constructor & Destructor Documentation

FileKeyC | ( |  | ) | `[protected]`

| Default constructor.

FileKeyC | ( | PajaTypes::int32 | i32Time | ) | `[protected]`

| Creates new key and assign it the specified time.

FileKeyC | ( | Edit::EditableI * | pOriginal | ) | `[protected]`

| Constructor with reference to the original.

virtual ~FileKeyC | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

virtual void copy | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Reimplemented from KeyC.

virtual Edit::DataBlockI* create | ( | Edit::EditableI * | pOriginal | ) | `[virtual]`

| Creates new file handle (used internally), see Edit::EditableI::create(). Reimplemented from KeyC.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Create new key with specified number fo channels. Create new key with zero no channels. Reimplemented from KeyC.

FileKeyC* create_new | ( |  | ) | `[static]`

| Create new key with zero no channels. Reimplemented from KeyC.

virtual Import::FileHandleC* get_file_handle | ( |  | ) | `[virtual]`

| Returns the file handle used.

virtual PajaTypes::int32 get_time_offset | ( |  | ) | const`[virtual]`

| Returns the time offset.

virtual PajaTypes::float32 get_time_scale | ( |  | ) | const`[virtual]`

| Returns the time scale.

virtual PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[virtual]`

| Serialize the key from a Demopaja input stream. Reimplemented from KeyC.

virtual void restore | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Reimplemented from KeyC.

virtual PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[virtual]`

| Serialize the key to a Demopaja output stream. Reimplemented from KeyC.

virtual void set_file_handle | ( | Import::FileHandleC * | pHandle | ) | `[virtual]`

| Sets the file handle used.

virtual void set_time_offset | ( | PajaTypes::int32 | i32Offset | ) | `[virtual]`

| Sets the time offset.

virtual void set_time_scale | ( | PajaTypes::float32 | f32Scale | ) | `[virtual]`

| Sets the time scale.